#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define F first
#define S second
#define pb push_back
#define all(x) x.begin(),x.end()

//#define int long long
struct Node {
    int l;
    int r;
    int p;
    int cnt;

    Node() {
        l = -1;
        r = -1;
        p = -1;
        cnt = 1;
    }
};

//struct segtree{
//    vector<int> tree;
//
//    void start(int n,int val){
//        tree.assign(4*n,val);
//    }
//
//};


const int N = 1e5 + 100;
int tin[N];
int tout[N];
Node a[N];
int lans[N];
int curtime = 0;

void dfs(int v, int sum) {
    lans[v] = sum;
    tin[v] = curtime;
    curtime++;
    if (a[v].l != -1) {
        dfs(a[v].l, sum);
        a[v].cnt += a[a[v].l].cnt;
        sum += a[a[v].l].cnt;
    }
    if (a[v].r != -1) {
        dfs(a[v].r, sum);
        a[v].cnt += a[a[v].r].cnt;
    }
    tout[v] = curtime;
    curtime++;
}

int type[N];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    for (int i = 1; i <= n; i++) {
        int l, r;
        cin >> l >> r;
        if (l != 0) {
            a[i].l = l;
            a[l].p = i;
        }
        if (r != 0) {
            a[i].r = r;
            a[r].p = i;
        }
    }
    dfs(1, 0);
    memset(type, -1, sizeof(type));
    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int l, r, x;
            cin >> l >> r >> x;
            for (; l <= r; l++) {
                type[l] = x;
            }
        } else {
            int i;
            cin >> i;
            int ans = lans[i];
            if (type[i] == 1) {
                ans += a[i].cnt - 1;
            } else if (type[i] == 0 && a[i].l != -1) {
                ans += a[a[i].l].cnt;
            }
            while (a[i].p != -1) {
                int j = i;
                i = a[i].p;
                if (type[i] == -1) {
                    ans++;
                } else if (type[i] == 0 && a[i].r == j) {
                    ans++;
                }
            }
            cout << ans + 1 << "\n";
        }
    }
    return 0;
}
