#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define pb push_back
//#define int long long
const int N = 2e5 + 10;
vector<int> g[N];
int n, k, t;
int mxlen[N];
int c[N];

int dfs2(int v, int p) {
    mxlen[v] = 0;
    for (int u: g[v]) {
        if (u == p) {
            continue;
        }
        mxlen[v] = max(mxlen[v], dfs2(u, v));
    }
    return mxlen[v] + 1;
}

void primes(int y, int val) {
    for (int i = 1; i * i <= y; i++) {
        if (y % i == 0) {
            c[i] += val;
            if (i * i != y) {
                c[y / i] += val;
            }
        }
    }
}

ll check(int x, int s) {
    ll cnt = c[x];
    for (int u: g[s]) {
        if (mxlen[u] % x == x - 1) {
            cnt--;
        }
    }
    if (mxlen[s] % x == x - 1) {
        cnt--;
    }
    return cnt;
}

int solve(int s) {
    int l = 0;
    int r = n + 1;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (check(m, s) <= k) {
            r = m;
        } else {
            l = m;
        }
    }
    return r;
}

int ans[N];

void go(int s, int f) {
    primes(mxlen[s] + 1, -1);
    primes(mxlen[f] + 1, -1);
    mxlen[s] = 0;
    for (int u: g[s]) {
        if (u != f) {
            mxlen[s] = max(mxlen[s], mxlen[u] + 1);
        }
    }
    primes(mxlen[s] + 1, 1);
    mxlen[f] = 0;
    for (int u: g[f]) {
        mxlen[f] = max(mxlen[f], mxlen[u] + 1);
    }
    primes(mxlen[f] + 1, 1);
}

void dfs(int v, int p) {
    ans[v] = solve(v);
    for (int u: g[v]) {
        if (u == p) {
            continue;
        }
        go(v, u);
        dfs(u, v);
    }
    if (v != p) {
        go(v, p);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> k >> t;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        g[u].pb(v);
        g[v].pb(u);
    }
    dfs2(1, 1);
    for (int i = 1; i <= n; i++) {
        primes(mxlen[i] + 1, 1);
    }
    if (t == 0) {
        cout << solve(1);
        return 0;
    }
    dfs(1,1);
    for(int i=1;i<=n;i++){
        cout << ans[i] << ' ';
    }
    return 0;
}